<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->
<ng-container *ngIf="decryptStatus$ | async as decryptStatus">
	<h1 class="h2 fw-medium mb-3">
		{{ 'decrypt.title' | translate }}
	</h1>
	<p class="mb-4">
		{{ 'decrypt.instruction' | translate }}
	</p>

	<section *ngIf="exportableBallotBoxes.size" class="mb-5">
		<sdm-page-actions [forceReady]="decryptStatus !== WorkflowStatus.Complete">
			<i aria-hidden="true" class="bi bi-info-circle" onReady></i>
			<p onReady [innerHTML]="'decrypt.tallySection.fullTallyNotReady' | translate:{count: exportableBallotBoxes.size, total: (ballotBoxById.size)}">
			</p>

			<button class="btn btn-link" type="button" onReady (click)="displayTestVotes(testVotes)">
				<i aria-hidden="true" class="bi bi-eye"></i>
				{{ 'decrypt.tallySection.displayTestVotes' | translate }}
			</button>
			<button [disabled]="true" class="btn btn-primary" onReady sdmRouterLinkNext type="button">
				{{ 'common.next' | translate }}
				<i aria-hidden="true" class="bi bi-arrow-right-circle"></i>
			</button>

			<i aria-hidden="true" class="bi bi-check-circle" onComplete></i>
			<p onComplete>
				{{ 'decrypt.tallySection.fullTallyReady' | translate }}
			</p>
			<button [disabled]="decryptStatus !== WorkflowStatus.Complete" class="btn btn-primary" onComplete sdmRouterLinkNext type="button">
				{{ 'common.next' | translate }}
				<i aria-hidden="true" class="bi bi-arrow-right-circle"></i>
			</button>
		</sdm-page-actions>

		<sdm-ballot-box-list
				[ballotBoxes]="exportableBallotBoxes"
				[describedById]="'exportable-ballot-box-list-desc'"
				[showIdle]="false"
		></sdm-ballot-box-list>
	</section>

	<section *ngIf="decryptableBallotBoxes.size">
		<sdm-page-actions #pageActionsComponent>
			<ng-container onReady>
				<i aria-hidden="true" class="bi bi-unlock"></i>
				<p id="decryptable-ballot-box-list-desc">{{ 'decrypt.mixedAndDownloadedBoxesSection.decryptionReady' | translate }}</p>
				<button (click)="decrypt()" [disabled]="!hasSelection" class="btn btn-primary" type="button">
					<i aria-hidden="true" class="bi bi-unlock"></i>
					{{ 'decrypt.mixedAndDownloadedBoxesSection.decryption' | translate }}
				</button>
			</ng-container>
			<ng-container onProgress>
				<div class="spinner">
					<span aria-hidden="true" class="spinner-border"></span>
					<span class="visually-hidden" role="status">{{ 'common.loading' | translate }}</span>
				</div>
				<p>{{ 'decrypt.mixedAndDownloadedBoxesSection.decryptionInProgress' | translate }}</p>
			</ng-container>
			<ng-container onError>
				<i aria-hidden="true" class="bi bi-x-circle fs-2"></i>
				<p>{{ 'decrypt.mixedAndDownloadedBoxesSection.error.' + pageActionsComponent.errorFeedbackCode  | translate }}</p>
			</ng-container>
		</sdm-page-actions>

		<sdm-ballot-box-list
				(ballotBoxesSelected)="selectedBallotBoxes = $event"
				[ballotBoxes]="decryptableBallotBoxes"
				[describedById]="'decryptable-ballot-box-list-desc'"
				[enableCheckbox]="decryptStatus !== WorkflowStatus.InProgress && decryptStatus !== WorkflowStatus.Error "
				[showIdle]="false"
		></sdm-ballot-box-list>
	</section>
</ng-container>

<ng-template #testVotes let-modal>
	<div class="modal-header">
		<h1 class="modal-title h4" id="testVotes-modal-title">
			{{ 'decrypt.testVotesModal.title' | translate }}
		</h1>
	</div>
	<div class="modal-body">
		<div class="spinner" *ngIf="loadingBallotBoxTestVotes">
			<span aria-hidden="true" class="spinner-border"></span>
			<span class="visually-hidden" role="status">{{ 'common.loading' | translate }}</span>
		</div>
		<ng-container *ngIf="!loadingBallotBoxTestVotes && ballotBoxTestVotes.length > 0">
			<sdm-ballot-box-test-vote-list [ballotBoxTestVotes]="ballotBoxTestVotes"></sdm-ballot-box-test-vote-list>
		</ng-container>
	</div>
	<div class="modal-footer">
		<button (click)="modal.close(true)" class="btn btn-primary" type="button">
			{{ 'common.close' | translate }}
		</button>
	</div>
</ng-template>
